// common.cpp
#include <random>
#include "common.hpp"

std::default_random_engine generator;
void InitializeGenerator(void)
{
    generator.seed(std::random_device{}());
}

// Returns a newly generated number
int GenerateRandomNumber(int generationLimit)
{
    int generatedNumber;
    std::uniform_int_distribution<> distribution(0, generationLimit - 1);
    generatedNumber = distribution(generator);
    return generatedNumber;
}

GameSpace::GameSpace(void) {
    Reset();
}

void GameSpace::Reset(void) {
    m_bFood = 0;
    m_bSnake = 0;
    m_bVisited = 0;
}
