#ifndef PLAYERINTERFACE_HPP
#define PLAYERINTERFACE_HPP

#include "common.hpp"
#include <SFML/Graphics.hpp>

const int kGridSize = 25;

PlayerDirection GetPlayerInput(void);

class PlayerOutput 
{
public:
    sf::Vector2f gameBoundaries;
    PlayerOutput(void);
    bool IsOpen(void);
    void CheckContinue();
    void DisplayGameState(std::vector< std::vector<GameSpace> >& gameBoard, int score);
    void DisplayScore(int score);
    void StartGameWindow(void);
    void SetShowGame(bool isShowing);
private:
    void CheckWindowEvents(void);
    void DisplayEndScreen(void);
    void DrawEmpty(sf::Vector2f location);
    void DrawFood(sf::Vector2f location);
    void DrawSnake(sf::Vector2f location);
    sf::RenderWindow gameWindow;
    sf::VideoMode gameVideoSettings;
    sf::RectangleShape drawObject;
    sf::Event event;
    bool isWindowAlive = false;
    sf::Time delay = sf::milliseconds(12);
};

#endif
